;*********************************************************;
;							  ;
;     SBC-2 v2.5 Video Display Driver (c)2003-2004	  ;
;                        v1.0  				  ;
;                  by Daryl Rictor   			  ;
;              http://65c02.tripod.com/ 		  ;
;							  ;
;							  ;
;*********************************************************;

;
;  6522 Port Definitions
; Moved to VIA2 to avoid conflict with the Serial IEC board.
;
VIDEO	=  $7F61		; VIA2 Port A
Vidddr	=  $7F63		; Via2 Port A DDR
Vidpcr  =  $7F6C		; Via2 peripheral control register
Vidbsy  =  $7F6D		; Via2 IFR bit 1
VidIRQ	=  $7F6E		; Via2 IER
Out_Vec =  $03F1		; The SBC-2 Output port vector

; Reserved
;V_idle	       =     $E2	       ; Bit 7 holds the next expected idle state

;	*= $1000		; can start anywhere

;----------------------------------------------------------------------
; Call this once to initialize the interface
; it sets up Port A as an output port and enables Handshaking	
;----------------------------------------------------------------------
InitDisp			
	lda  #$ff		; Set Video Port as output
	sta  Vidddr		; 
	sei			; disable Interrupts until after we change things
	lda  VidIRQ		; get IER value
	and  #$FD		; disable CA1 IRQ	
	sta  VidIRQ		; save it
	lda  Vidpcr		; get current value
	and  #$F0		; mask out Port A bits
	ora  #$0B		; set output handshake mode on port A
	sta  Vidpcr		; to CA2=pulse mode, CA1=Positive Active Edge
	lda  #$0C		; CLS cmd
	sta  Video		; write it to the Display and init the CA1 flag in the IFR
	lda  #<VOutput		; get low address of the Output Routine
	sta  Out_vec		; set the SBC's output vector address (low byte)
	lda  #>VOutput		; get high address of the Output Routine
	sta  Out_vec+1		; set the SBC's output vector address (high byte)
	cli			; Enable Interrupts again
	rts			; done

;----------------------------------------------------------------------
; Call this to write the byte in the Accumulator to the display
;----------------------------------------------------------------------
VOutput
	pha			; save data in A reg
VOut1	lda  Vidbsy		; get status
	and  #$02		; mask bit 1
	beq  VOut1		; wait for CA1 Flag to go hi (Ready for next byte)
	pla			; restore data to A reg
	sta  video		; write the byte and clr CA1 flag in IFR
	rts			; done
;----------------------------------------------------------------------
; End of Program.
;----------------------------------------------------------------------
AA_end_vidbios

